

/*******************************************************************************
 * Instance třídy {@code Obdelnik} představují ...
 *
 * @author    Petr Bilek
 * @version   1.00.000
 */
public class Obdelnik
{
//== KONSTANTNÍ ATRIBUTY TŘÍDY =================================================
//== PROMĚNNÉ ATRIBUTY TŘÍDY ===================================================
//== KONSTANTNÍ ATRIBUTY INSTANCÍ ==============================================
//== PROMĚNNÉ ATRIBUTY INSTANCÍ ================================================
    private double sirka = 1;
    private double vyska = 1;
//== PŘÍSTUPOVÉ METODY ATRIBUTŮ TŘÍDY ==========================================
//== OSTATNÍ NESOUKROMÉ METODY TŘÍDY ===========================================

//##############################################################################
//== KONSTRUKTORY A TOVÁRNÍ METODY =============================================

    /***************************************************************************
     *
     */
    /**
     * bezparametricky konstruktor
     * nastavuje vysku a sirku na defaultni hodnoty (1)
     */
    public Obdelnik()
    {
        this(1,1);
    }
    
    /**
     * Konstrutkor, nastavuje vysku a sirku
     * @param s sirka
     * @param v vyska
     */
    public Obdelnik(double s, double v)
    {
         setSirka(s);
          setVyska(v);
    }
    
    /**
     * Kopirovaci konstruktor
     * @param obd kopirovany obdelnik
     */
    public Obdelnik(Obdelnik obd)
    {
        this(obd.getSirka(),obd.getVyska());
    }

//== ABSTRAKTNÍ METODY =========================================================
//== PŘÍSTUPOVÉ METODY INSTANCÍ ================================================

    /**
     * Pristupova metoda pro sirku obdelniku
     * 
     * @return sirka obdelnika
     */
    public double getSirka()
    {
            return sirka;
    }
    
    /**
     * Pristupova metoda pro vysku obdelniku
     * 
     * @return vyska obdelnika
     */
    public double getVyska()
    {
            return vyska;
    }

    /**
     * Nastaveni sirky obdelnika
     * nastavi pouze platnou hodnotu sirky, jinak defaultni hodnotu
     * 
     * @param s sirka obdelnika
     * 
     */
    public void setSirka(double s)
    {
        sirka = platnaHodnota(s);
    }
    
     /**
     * Nastaveni vysky obdelnika
     * nastavi pouze platnou hodnotu vysky, jinak defaultni hodnotu
     * 
     * @param v vyska obdelnika
     * 
     */
    public void setVyska(double v)
    {
        vyska = platnaHodnota(v);
    }
    
    /**
     * Vraci obvod obdelnika
     * 
     * @return obvod obdelnika
     */
    public double getObvod()
    {
            return 2*getVyska() + 2* getSirka();
    }
    
    /**
     * Vraci obsah obdelnika
     * 
     * @return obsah obdelnika
     */
    public double getObsah()
    {
            return getVyska()*getSirka();
    }
//== OSTATNÍ NESOUKROMÉ  METODY INSTANCÍ =======================================
    
    public String toString()
    {
        return String.format("Obdélník [%.2f x %2f]",getSirka(),getVyska());
    }
//== SOUKROMÉ A POMOCNÉ METODY TŘÍDY ===========================================

    /**
     * Kontorluje platnou hodnotu pro sirku a vysku. Vraci platnou hodnotu,
     * nebo defaultni hodnotu 1.
     * 
     * @param d Overovana hodnota
     * @return parametr d nebo 1
     */
    private double platnaHodnota(double d)
    {
         if(d > 0.0 && d <= 20.0)
            return d;
         return 1;
    }
//== SOUKROMÉ A POMOCNÉ METODY INSTANCÍ ========================================
//== VNOŘENÉ A VNITŘNÍ TŘÍDY ===================================================
//== TESTOVACÍ METODY A TŘÍDY ==================================================
//
//     /***************************************************************************
//      * Testovací metoda.
//      */
//     public static void test()
//     {
//          Obdelnik instance = new Obdelnik();
//     }
//     /** @param args Parametry příkazového řádku - nepoužité. */
//     public static void main( String... args ) { test(); }
}
